<template>
  <div>
    <div>
      <el-form :inline="true" class="orderform" size="mini">
        <el-row>
          <el-form-item>
            <el-input v-model="tag" style="width: 250px" placeholder="请输入按钮名称" class="search_tag" clearable/>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" @click="btn_search()"><i class="el-icon-search"/> 查询</el-button>
            <el-button @click="btn_clear()"><i class="el-icon-remove-outline"/> 重置</el-button>
            <el-button type="primary" icon="el-icon-plus" @click="addButton">添加</el-button>
          </el-form-item>
        </el-row>
      </el-form>
      <el-table
        ref="multipleTable"
        :data="tableData"
        :highlight-current-row="true"
        border>
        <el-table-column
          prop="id"
          label="编号"/>
        <el-table-column
          prop="btnName"
          label="按钮名称"/>
        <el-table-column
          prop="btnCode"
          label="按钮代码"/>
        <el-table-column
          prop="menu.menuName"
          label="所属菜单"/>
        <el-table-column
          prop="description"
          label="备注"/>
        <el-table-column
          fixed="right"
          label="操作">
          <template slot-scope="scope">
            <el-button type="text" @click="editButton(scope.row)">编辑</el-button>
            <el-button type="text" @click="deleteButtonConfirm(scope.row)">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
      <div class="mydiv">
        <el-pagination
          :current-page.sync="pageNo"
          :page-sizes="[10, 50, 100, 300,1000]"
          :page-size="pageSize"
          :total="totalDataNumber"
          layout="sizes,total, prev, pager, next"
          class="table-pagination"
          @size-change="handleSizeChange"
          @current-change="handleCurrentChange"/>
      </div>

    </div>
    <!--弹出框-->
    <el-dialog :visible.sync="dialogFormVisiable" title="添加按钮">
      <el-form :rules="rules" :model="addForm" label-width="100px" >
        <el-form-item label="按钮代码" prop="buttonCode">
          <el-input v-model="addForm.buttonCode" :maxlength= "20" placeholder="请输入按钮代码" size="mini"/>
        </el-form-item>
        <el-form-item label="按钮名称" prop="buttonName">
          <el-input v-model="addForm.buttonName" :maxlength= "30" placeholder="请输入按钮名称" size="mini"/>
        </el-form-item>
        <el-form-item label="按钮菜单" prop="menuId">
          <el-select v-model="addForm.menuId" clearable placeholder="请选择菜单" size="mini">
            <el-option
              v-for="item in menus"
              :key="item.id"
              :label="item.menuName"
              :value="item.id"/>
          </el-select>
        </el-form-item>
        <el-form-item label="描述">
          <el-input v-model="addForm.description" :maxlength= "30" rows="3" type="textarea"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button size="mini" @click="addButtonCancel">取 消</el-button>
        <el-button size="mini" type="primary" @click="addButtonSubmit">确 定</el-button>
      </div>
    </el-dialog>
    <el-dialog :visible.sync="dialogModifyVisiable" title="修改按钮">
      <el-form :rules="rules" :model="modifyForm" label-width="100px">
        <el-form-item label="按钮代码" prop="buttonCode">
          <el-input v-model="modifyForm.buttonCode" placeholder="请输入按钮代码" size="mini"/>
        </el-form-item>
        <el-form-item label="按钮名称" prop="buttonName">
          <el-input v-model="modifyForm.buttonName" placeholder="请输入按钮名称" size="mini"/>
        </el-form-item>
        <el-select v-model="modifyForm.menuId" prop="menuId" clearable placeholder="请选择菜单" size="mini">
          <el-option
            v-for="item in menus"
            :key="item.id"
            :label="item.menuName"
            :value="item.id"/>
        </el-select>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button size="mini" @click="updateButtonCancel">取 消</el-button>
        <el-button size="mini" type="primary" @click="updateButton">确 定</el-button>
      </div>
    </el-dialog>
    <!-- 点击删除按钮，删除确认框-->
    <el-dialog
      :visible.sync="deleteDialogVisible"
      title="提示"
      width="30%">
      <span>确定删除选择的按钮? </span>
      <span slot="footer" class="dialog-footer">
        <el-button @click="deleteDialogVisible = false">取 消</el-button>
        <el-button type="primary" @click="handleClickDelete">确 定</el-button>
      </span>
    </el-dialog>
  </div>
</template>

<script>
import axios from 'axios'

export default {
  name: 'Index',
  data() {
    return {
      rules: {
        buttonName: [{ required: true, message: '请输入按钮名称', trigger: 'blur' }],
        buttonCode: [{ required: true, message: '请输入按钮代码', trigger: 'blur' }],
        menuId: [{ required: true, message: '请选择菜单', trigger: 'blur' }]
      },
      menus: [],
      tag: '',
      allData: [], // 所有前端分页数据
      tableData: [], // 表格数据 仅展示当前页的数据
      pageNo: 1, // 当前页数
      totalDataNumber: 0, // 总记录数
      pageSize: 10,
      formLabelWidth: '100px', // 弹出框form宽
      dialogAuthVisiable: false,
      dialogFormVisiable: false,
      dialogModifyVisiable: false,
      deleteDialogVisible: false,
      addForm: {
        buttonCode: '',
        buttonName: '',
        menuId: '',
        description: ''
      },
      modifyForm: {
        id: '',
        buttonCode: '',
        buttonName: '',
        menuId: '',
        description: ''
      }
    }
  },
  created() {
    this.getAllMenus()
    this.btn_search()
  },
  mounted() {
  },
  methods: {
    getAllMenus() {
      const vm = this
      axios.get(process.env.BASE_API + '/menu/list', {
        params: {
          tag: ''
        }
      }).then(function(response) {
        var obj = response.data
        if (obj.code !== 10000) {
          // vm.$message.error(obj.message)
        } else {
          vm.menus = obj.data
        }
      }).catch(function(error) {
        alert(error)
      })
    },
    btn_search() {
      const vm = this
      axios.get(process.env.BASE_API + '/button/list', {
        params: {
          tag: this.tag
        }
      }).then(function(response) {
        var obj = response.data
        if (obj.code !== 10000) {
          vm.$message.error(obj.message)
          vm.totalDataNumber = 0
          vm.allData = []
          vm.tableData = []
        } else {
          vm.totalDataNumber = parseInt(obj.total)
          if (vm.totalDataNumber > 0) {
            vm.allData = obj.data
            vm.tableData = obj.data.slice(0, vm.pageSize)
          } else {
            vm.allData = []
            vm.tableData = []
          }
        }
      }).catch(function(error) {
        alert(error)
      })
    },
    btn_clear() {
      this.tag = ''
      this.btn_search()
    },
    handleCurrentChange() {
      this.tableData = this.allData.slice((this.pageNo - 1) * this.pageSize, this.pageNo * this.pageSize)
    },
    handleSizeChange(val) {
      this.pageSize = val
      this.tableData = this.allData.slice((this.pageNo - 1) * this.pageSize, this.pageNo * this.pageSize)
    },
    addButton() {
      this.dialogFormVisiable = true
    },
    addButtonCancel() {
      this.dialogFormVisiable = false
      this.clearForm()
    },
    clearForm() {
      this.addForm.buttonName = ''
      this.addForm.buttonCode = ''
      this.addForm.menuId = ''
      this.addForm.description = ''
    },
    addButtonSubmit() {
      const vm = this
      var params = new URLSearchParams()
      if (vm.addForm.buttonName === '') {
        this.$message.error('请输入按钮名称')
        return
      }
      params.append('btnCode', vm.addForm.buttonCode)
      params.append('btnName', vm.addForm.buttonName)
      params.append('menu', vm.addForm.menuId)
      params.append('description', vm.addForm.description)
      axios.post(process.env.BASE_API + '/button/create', params).then(function(response) {
        var obj = response.data
        if (obj.code !== 10000) {
          vm.$message.error(obj.message)
        } else {
          vm.$message(obj.message)
          vm.pageNo = 1
          vm.clearForm()
          vm.btn_search()
        }
      }).catch(function(error) {
        alert(error)
      })
      this.dialogFormVisiable = false
    },
    editButton(row) {
      this.dialogModifyVisiable = true
      this.modifyForm = row
    },
    updateButtonCancel() {
      this.dialogModifyVisiable = false
      this.modifyForm = ''
      this.btn_search()
    },
    updateButton() {
      const vm = this
      var params = new URLSearchParams()
      params.append('id', vm.modifyForm.id)
      params.append('btnCode', vm.modifyForm.buttonCode)
      params.append('btnName', vm.modifyForm.buttonName)
      params.append('menu', vm.modifyForm.menuId)
      params.append('description', vm.modifyForm.description)
      axios.post(process.env.BASE_API + '/button/update', params).then(function(response) {
        var obj = response.data
        if (obj.code !== 10000) {
          vm.$message.error(obj.message)
        } else {
          vm.$message(obj.message)
          vm.pageNo = 1
          vm.btn_search()
        }
        vm.modifyForm = ''
      }).catch(function(error) {
        alert(error)
      })
      this.dialogModifyVisiable = false
    },
    deleteButtonConfirm(row) {
      this.deleteButtonId = row.id
      this.deleteDialogVisible = true
    },
    handleClickDelete() {
      const vm = this
      var params = new URLSearchParams()
      params.append('id', vm.deleteButtonId)
      axios.post(process.env.BASE_API + '/button/delete', params).then(function(response) {
        var obj = response.data
        if (obj.code !== 10000) {
          vm.$message.error(obj.message)
        } else {
          vm.$message(obj.message)
          vm.pageNo = 1
          vm.btn_search()
        }
      }).catch(function(error) {
        alert(error)
      })
      this.deleteDialogVisible = false
    },
    setButtonAuth(id) {
    }
  }
}
</script>

<style scoped>
  .orderform {
    padding-top: 20px;
    padding-left: 10px;
    padding-right: 10px;
  }

  .mydiv {
    float: right;
    margin-right: 10px;
  }
</style>
